
#include "main_2525.h"
//#include "PIC18F252_registers.h"
#include "my_lcd.c"

// 
void bcd(ulong);
void bcd_amper(ulong);
void bcd_volt(ulong);
void setup_fun();  // 
//--------------------------------------------------------------------------
// 
//    REF=4096
//     0.1 ->LM358 
//   10   4  ,   
//4096/1024=4=1   , 1=1000 /4=250   
//  25   =100 



//---------------------------------------------------------------------------
// 
//  = 9 ,  = 1      =40
//   =4096/1024=4
//    10   U=4*10*= 

//-----------------------------------------------------------------------------
//     65 s 
#int_timer0
void timer0()
{
   //  , 65*3=195 
   if (input(setup)) 
   { 
      if (ykaz_setup->open) --ykaz_setup->open; 
      ykaz_setup->close=3;    
   } 
   else 
   { 
      if (ykaz_setup->close) --ykaz_setup->close; 
      ykaz_setup->open=3;    
   }
   
   //  , 65*3=195 
   if (input(razrad)) 
   { 
      if (ykaz_razrad->open) --ykaz_razrad->open; 
      ykaz_razrad->close=3;    
   } 
   else 
   { 
      if (ykaz_razrad->close) --ykaz_razrad->close; 
      ykaz_razrad->open=3;    
   }
}
void main()
{
   setup_comparator(NC_NC_NC_NC);
   setup_spi(SPI_SS_DISABLED);
   setup_wdt(WDT_OFF);
   setup_timer_0(RTCC_INTERNAL); //  65 
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
   set_tris_C(0xff);
   //  
   output_bit(yprav,0);
   // 
   lcd_init();
   delay_ms(6);
   // 
   //setup_adc_ports(RA0_RA1_ANALOG_RA3_REF);
   setup_adc_ports(AN0_TO_AN1|VSS_VREF);
   
   setup_adc(ADC_CLOCK_INTERNAL);
   
   // ,   .
   enable_interrupts(int_timer0);   // 
   disable_interrupts(int_timer1);   //  1
   disable_interrupts(global);
   
   //   
   ykaz_volt_amper=&struct_volt_amper;
   ykaz_setup=&struct_setup;
   ykaz_razrad=&struct_razrad;
   ykaz_indic=&struct_indic;
   ykaz_eeprom=&struct_eeprom;
   ykaz_eeprom->peeprom=&ykaz_volt_amper->ystav_amper;
  
   //   setup!=0
   ykaz_setup->close=3;
   //       1
    ykaz_eeprom->first=read_eeprom(1);
    ykaz_eeprom->two=read_eeprom(2);
    *ykaz_eeprom->peeprom=ykaz_eeprom->first;
    *(ykaz_eeprom->peeprom+1)=ykaz_eeprom->two;
   //ykaz_volt_amper->ystav_amper=read_eeprom(1);
   restart_wdt();
   //
while(1)
   {  
   restart_wdt();
   //    
   // 
   
   //--------------------------------------------------------------------------
   //
   set_adc_channel(0); //volt
   delay_us(30);
   //  4*10=40 
   ykaz_volt_amper->ismer_volt=read_adc();
   //     ,      1
   //   
   set_adc_channel(1); //amper
   delay_us(30);
   //  4*10=40 
   ykaz_volt_amper->ismer_amper=read_adc();
   //       , 
   //if(ykaz_volt_amper->ismer_amper>625||ykaz_volt_amper->ismer_amper<14)
     // ykaz_volt_amper->ismer_amper=625; // 
   //,  
   enable_interrupts(global);
   
   //--------------------------------------------------------------------------
   //     
   if(ykaz_volt_amper->ismer_amper>=ykaz_volt_amper->ystav_amper)
   { 
       
         //  
         output_bit(yprav,0);
         //    
         lcd_putc("\fAmper\nMax");
       while(1)
       {
         restart_wdt();
         //  setup  ,  
         if(!ykaz_setup->close)
         {
           restart_wdt();
           setup_fun();  //   
           reset_cpu();
         }
       }
   }
   else
   {
       //  
       output_bit(yprav,1);
       //     
       //ykaz_indic->off=0;
   }
   //-------------------------------------------------------------------------
   //  setup  ,  
   if(!ykaz_setup->close)
      setup_fun();
   //----------------------------------------------------------------------------
   //  32        
   if(ysred_flag==8)
   {
      restart_wdt();
      //         8
      //         
      ykaz_volt_amper->ismer_volt=symma_volt>>3;   //  8
      ykaz_volt_amper->ismer_amper=symma_amper>>3; //  8
      //--------------------------------------------------------------------------
      // 
      ykaz_volt_amper->ismer_volt=(ykaz_volt_amper->ismer_volt<<2); //*4
      ykaz_volt_amper->ismer_volt*=10;
      bcd_volt(ykaz_volt_amper->ismer_volt);
   
      //  
      lcd_gotoxy(1,1);
      lcd_putc("U=");
      lcd_putc(tusahi+0x30);
      lcd_putc(sotni+0x30);
      lcd_putc(",");
      lcd_putc(dec+0x30);
      lcd_putc("B");
   
//!      //  
//!      ykaz_indic->bdc_i_ystav=ykaz_volt_amper->ystav_amper/9; // 200 * 
//!      ykaz_indic->bdc_i_ystav*=200; //
//!      bcd_amper(ykaz_indic->bdc_i_ystav);
//!   
//!      //   
//!      lcd_putc("  Iy=");
//!      lcd_putc(tusahi+0x30);
//!      lcd_putc(",");
//!      lcd_putc(sotni+0x30);
//!      lcd_putc("A");
   
      //  
      ykaz_volt_amper->ismer_amper=ykaz_volt_amper->ismer_amper<<2; //Iizm=(*4)/10
      ykaz_volt_amper->ismer_amper/=10; //   , 
      bcd(ykaz_volt_amper->ismer_amper);
   
      //   
      lcd_putc("\nI=");
      lcd_putc(sotni+0x30);
      lcd_putc(",");
      lcd_putc(dec+0x30);
      //lcd_putc(edin+0x30);
      lcd_putc("A");
      
      //     
      ysred_flag=0;
      symma_volt=0;
      symma_amper=0;
   }
   else
   {
      restart_wdt();
      ysred_flag++;
      symma_volt+=ykaz_volt_amper->ismer_volt;
      symma_amper+=ykaz_volt_amper->ismer_amper;
   }
   }
}

void bcd_volt(ulong hislo)
{
   restart_wdt();
   //  ,,  
   tusahi=hislo/10000;
   temp1=tusahi*10000; //  
   temp2=hislo-temp1;  //       
   restart_wdt();
   sotni=temp2/1000;
   temp1=sotni*1000;
   dec=(temp2-temp1)/100;
   // 
   //temp=(hislo-temp);//  ,    
   //temp2=sotni*10;
   //temp2*=10;
   //raznos=temp-temp2;
   //dec=raznos/10;
   //edin=raznos-dec*10;
}

void bcd(ulong hislo)
{
   restart_wdt();
    //  ,,  
   tusahi=hislo/1000;
   temp1=tusahi*1000;
   temp_tusahi=temp1;
   temp2=hislo-temp1;  //       
   restart_wdt();
   sotni=temp2/100;
   temp1=sotni*100;
   temp_sotni=temp1;
   dec=((hislo-temp_tusahi)-temp_sotni)/10;
   //temp_dec=dec*10;
   //edin=((hislo-temp_tusahi)-temp_sotni)-temp_dec;
   // 
   //temp=(hislo-temp);//  ,    
   //temp2=sotni*10;
   //temp2*=10;
   //raznos=temp-temp2;
   //dec=raznos/10;
   //edin=raznos-dec*10;
}

void bcd_amper(ulong hislo)
{
   restart_wdt();
   //  ,,  
   sotni=hislo/100;
   temp=hislo-(sotni*100);
   dec=temp/10;
   edin=(hislo-temp)-dec*10;
}

void setup_fun()
{
   restart_wdt();
   //int item1[]=" Aplles";
   //int i;
   //  
   output_bit(yprav,0);
   //    
   while(!ykaz_setup->close);
   //    
   lcd_putc("\fSetup Iy\n");
   while(!ystav_flag)
   {
       restart_wdt();
       lcd_gotoxy(1,2); //  
       lcd_putc("Iy=");
       
       //     setup_fun()
       if(!ykaz_razrad->close)
       {
         ykaz_volt_amper->ystav_amper+=25; // 25*4=100mv==0.1 A
         if(ykaz_volt_amper->ystav_amper>1000)
            ykaz_volt_amper->ystav_amper=0;
       }
       while(!ykaz_razrad->close) restart_wdt();
         //
       
         //  
         ykaz_indic->bdc_i_ystav=ykaz_volt_amper->ystav_amper<<2; //Iyst=625-((Ived*20)/3)
         //ykaz_indic->bdc_i_ystav*=10; //
         bcd(ykaz_indic->bdc_i_ystav);
   
         //   
         lcd_putc(tusahi+0x30);
         lcd_putc(",");
         lcd_putc(sotni+0x30);
         //lcd_putc(dec+0x30);
        // lcd_putc(" ");
         lcd_putc("A");
      //?     
      
      //    
      if(!ykaz_setup->close)
         ystav_flag=1;    //    
   }
   //    
   while(!ykaz_setup->close)restart_wdt();
   
//!   //
//!   for(i=0;i<8;i++)
//!   {
//!     *((unsigned long*)item1+1)<<=1;
//!     if(item1[3]&0x80) 
//!      item1[4]=item1[4]|1;
//!     *(unsigned long*)item1<<=1;
//!   }
   //   
   ykaz_eeprom->peeprom=&ykaz_volt_amper->ystav_amper;
   ykaz_eeprom->first=*ykaz_eeprom->peeprom;
   ykaz_eeprom->two=*(ykaz_eeprom->peeprom+1);
   write_eeprom(1,ykaz_eeprom->first);
   write_eeprom(2,ykaz_eeprom->two);
   ystav_flag=0;
   restart_wdt();
   lcd_putc("\f");
}

